import { ParamSerializationConfig } from './converters/index.mjs';
export { NumberParam, ObjectParam, StringParam } from './converters/index.mjs';
import * as vue from 'vue';
import { FunctionPlugin } from 'vue';
import { LocationQueryValue } from 'vue-router';

declare function useQueryParam<TParam>(name: string, { serialize, deserialize }: ParamSerializationConfig<TParam>): vue.WritableComputedRef<TParam>;

declare function withDefault<TParam>({ serialize, deserialize }: ParamSerializationConfig<TParam>, defaultValue: NonNullable<TParam>): ParamSerializationConfig<TParam>;

type UseQueryParamPluginOptions = {
    debounceDelay?: number;
};
type QueryParamUpdate = {
    name: string;
    value: LocationQueryValue | LocationQueryValue[];
};
declare const PROVIDE_KEY = "vue-use-query-param";
type ProvideInterface = {
    queueUpdate: (update: QueryParamUpdate, updateUrl: (updates: QueryParamUpdate[]) => Promise<void>) => void;
};
declare const UseQueryParamPlugin: FunctionPlugin<UseQueryParamPluginOptions>;

export { PROVIDE_KEY, ParamSerializationConfig, type ProvideInterface, type QueryParamUpdate, UseQueryParamPlugin, useQueryParam, withDefault };
